//+------------------------------------------------------------------+
//|                                            Qore-Astro-Events.mq4 |
//|                                                        QoreLogic |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "QoreLogic"
#property link      "http://www.phuu.com"

#property indicator_chart_window
#define DELIM ";"
//#include <mysql.mqh>

//-- Configuration ----------------------/
extern string dbhost="localhost";
extern string dbuser="";
extern string dbpass="";
extern string dbname="";
extern int clientflag=0;
extern int dbport=3306;
extern string dbsocket="";

extern string dbtable = "astroevents";
//-- End Configuration ------------------/

extern int timezoneOffset = 2;
extern int periodMask = 100000; //PERIOD_MN1;

#import "libmysql.dll"
int mysql_init(int db);
int mysql_errno(int TMYSQL);
int mysql_real_connect( int TMYSQL,string host,string user,string password, string DB,int port,int socket,int clientflag);
int mysql_real_query(int TMSQL,string query,int length);
void mysql_close(int TMSQL);

int mysql_store_result(int TMSQL);
string mysql_fetch_row(int result);
int mysql_num_rows(int result);
void mysql_free_result(int result);
#import

int mysql;

int dateTime;
string aspect1, aspect2, aspect3, mCustomEffect;
double id;

string lines[];

int init()
{
   if (Period() < periodMask) 
   {
   
   string row;
   connect();
   string query="Select concat(';',concat_ws(';', id, aspect1, aspect2, aspect3, unix_timestamp(datetime))) from "+dbtable;
   int length=StringLen(query);
   mysql_real_query(mysql,query,length);
   int result = mysql_store_result(mysql);
   int numOfRows = mysql_num_rows(result);
   ArrayResize(lines, numOfRows);
   for (int i=0;i<numOfRows-1;i++) {
      string rowR;      
      row = mysql_fetch_row(result);
      decodeEvent(row);
      
      dateTime = dateTime + 3600*timezoneOffset;
      lines[i] = aspect1 + " | " + aspect2 + " | " + aspect3 + " | " + dateTime;
      
      ObjectDelete(lines[i]);
      if(!ObjectCreate(lines[i], OBJ_VLINE, 0, dateTime, 0)) {
         Print("error: can't create label_object! code #",GetLastError());
         return(0);
      }
      //ObjectSet(lines[i], OBJPROP_STYLE, STYLE_DOT);      
      ObjectSet(lines[i], OBJPROP_COLOR, 0x444444);
      //ObjectSet(lines[i], OBJPROP_LEVELWIDTH, 5);
         
      if (aspect2 == "Conj")
         ObjectSet(lines[i], OBJPROP_COLOR, 0x008888);
      if (aspect2 == "Oppos")
         ObjectSet(lines[i], OBJPROP_COLOR, 0x885555);
      if (aspect2 == "Qucnx")
         ObjectSet(lines[i], OBJPROP_COLOR, 0x444444);
      if (aspect2 == "Sesqu")
         ObjectSet(lines[i], OBJPROP_COLOR, 0x444444);
      if (aspect2 == "Sqr")
         ObjectSet(lines[i], OBJPROP_COLOR, 0x444488);
      if (aspect2 == "SSqr")
         ObjectSet(lines[i], OBJPROP_COLOR, 0x444444);
      if (aspect2 == "SSxt")
         ObjectSet(lines[i], OBJPROP_COLOR, Aqua);
      if (aspect2 == "Sxtil")
         ObjectSet(lines[i], OBJPROP_COLOR, 0x444444);
      if (aspect2 == "Trine")
         ObjectSet(lines[i], OBJPROP_COLOR, 0x448844);
   }
   
   mysql_free_result(result);

   }
   
   return(0);
}

int deinit()
{
   for (int i = 0; i < ArraySize(lines)-1; i++) {
      ObjectDelete(lines[i]);
   }
   mysql_close(mysql);
   return(0);
}

int start()
{
   return(0);
}

void connect() {

   mysql = mysql_init(mysql);
   if (mysql!=0) Print("allocated");
   int res=mysql_real_connect(mysql,dbhost,dbuser,dbpass,dbname,dbport,dbsocket,clientflag);
   int err=GetLastError();
   if (res==mysql) Print("connected");
   else Print("error=",mysql," ",mysql_errno(mysql)," ");

}

void decodeEvent(string trade) {

   int begin = StringFind(trade, DELIM)+1;
   int end = StringFind(trade, DELIM, begin);
   id = StrToInteger(StringSubstr(trade, begin, end-begin));
   
   begin = end+1;
   end = StringFind(trade, DELIM, begin);
   aspect1 = StringSubstr(trade, begin, end-begin);
   
   begin = end+1;
   end = StringFind(trade, DELIM, begin);
   aspect2 = StringSubstr(trade, begin, end-begin);
   
   begin = end+1;
   end = StringFind(trade, DELIM, begin);
   aspect3 = StringSubstr(trade, begin, end-begin);
   
   begin = end+1;
   end = StringFind(trade, DELIM, begin);
   dateTime = StrToInteger(StringSubstr(trade, begin, end-begin));
}

